package cn.org.bjca.trust.java.imserver.controller.user.v1;

import cn.org.bjca.trust.java.imserver.HttpResult;
import cn.org.bjca.trust.java.imserver.common.RabbitMQHelper;
import cn.org.bjca.trust.java.imserver.entitys.UserInfo;
import cn.org.bjca.trust.java.imserver.entitys.sys.ApplicationEntity;
import cn.org.bjca.trust.java.imserver.repository.UserRepository;
import cn.org.bjca.trust.java.imserver.repository.tenant.ApplicationRepository;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.web.bind.annotation.*;

import java.util.UUID;

@RestController
@RequestMapping("user/v1")
public class UserV1Controller {

    @Autowired
    private HttpServletRequest request;
    @Autowired
    private UserRepository userRepository;
    @Autowired
    private ApplicationRepository applicationRepository;

    @PostMapping("/register")
    public HttpResult<LoginData> register(@RequestBody LoginBean user, @RequestHeader HttpHeaders headers) throws Exception {
        String appid = headers.getFirst("appid");
        String userid = headers.getFirst("userid");
        String ostype = headers.getFirst("ostype");
        String token = headers.getFirst("token");
        if (null != appid && null != userid && null != ostype) {

            ApplicationEntity app = applicationRepository.findFirstByAppId(appid);
            if (null == app) return new HttpResult<>(201, "appId不存在", new LoginData());

            UserInfo userInfo = userRepository.findFirstByUserIdAndOsTypeAndAppId(userid, ostype, appid);
            if (null == userInfo) {
                System.out.println("-----------------用户不存在------------------");
                userInfo = new UserInfo();
                userInfo.setUserId(userid);
                userInfo.setNickName(userid);
                userInfo.setToken(UUID.randomUUID().toString());
                userInfo.setAppId(appid);
                userInfo.setOsType(ostype);
                userInfo.setPassword(UUID.randomUUID().toString());
                userRepository.save(userInfo);

                RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/users/" + userInfo.getToken(), "{\"username\":\"" + userInfo.getToken() + "\",\"password\":\"" + userInfo.getPassword() + "\",\"tags\":\"\"}");
                RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/permissions/%2F/" + userInfo.getToken(), "{\"username\":\"" + userInfo.getToken() + "\",\"vhost\":\"" + appid + "\",\"configure\":\".*\",\"write\":\".*\",\"read\":\".*\"}");
                RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/permissions/" + appid + "/" + userInfo.getToken(), "{\"username\":\"" + userInfo.getToken() + "\",\"vhost\":\"" + appid + "\",\"configure\":\".*\",\"write\":\".*\",\"read\":\".*\"}");
                RabbitMQHelper.requestByGetAndParams("http://114.115.203.60:15672/api/topic-permissions/" + appid + "/" + userInfo.getToken(), "{\"username\":\"" + userInfo.getToken() + "\",\"vhost\":\"" + appid + "\",\"exchange\":\"\",\"write\":\".*\",\"read\":\".*\"}");

            }

            return new HttpResult<>(200, "成功", new LoginData("114.115.203.60", "18883", userInfo));
        } else {
            return new HttpResult<>(201, "参数错误", new LoginData());
        }

    }

}
