package cn.org.bjca.trust.java.imserver.im.msg;


import cn.org.bjca.trust.java.imserver.entitys.DeviceEntity;
import cn.org.bjca.trust.java.imserver.enums.PacketType;
import cn.org.bjca.trust.java.imserver.im.bean.PacketMessage;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.OneToOne;
import lombok.Data;

@Entity
@Data
public class ConnectMessage extends PacketMessage {
    public ConnectMessage() {
        super(PacketType.CONNECT);
    }

    @OneToOne(cascade = CascadeType.ALL)
    @JoinColumn
    private DeviceEntity device;

    public ConnectMessage(DeviceEntity device) {
        super(PacketType.CONNECT);
        this.device = device;
    }

    public ConnectMessage copy() {
        ConnectMessage connectMessage = new ConnectMessage();
        connectMessage.setMsgId(this.getMsgId());
        connectMessage.setPacketType(this.getPacketType());
        connectMessage.setTimestamp(this.getTimestamp());
        connectMessage.setUserName(this.getUserName());
        connectMessage.setAppId(this.getAppId());
        connectMessage.setOsType(this.getOsType());
        connectMessage.setToken(this.getToken());
        DeviceEntity deviceEntity = new DeviceEntity();

        deviceEntity.setDeviceId(this.getDevice().getDeviceId());
        deviceEntity.set_uid(this.getDevice().get_uid());
        deviceEntity.setModel(this.getDevice().getModel());
        deviceEntity.setBrand(this.getDevice().getBrand());
        deviceEntity.setCpuAbi(this.getDevice().getCpuAbi());
        deviceEntity.setFingerprint(this.getDevice().getFingerprint());
        deviceEntity.setManufacturer(this.getDevice().getManufacturer());
        deviceEntity.setSupportedAbis(this.getDevice().getSupportedAbis());
        deviceEntity.setSupported32BitAbis(this.getDevice().getSupported32BitAbis());
        deviceEntity.setSupported64BitAbis(this.getDevice().getSupported64BitAbis());

        connectMessage.setDevice(deviceEntity);
        return connectMessage;
    }
}
